Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CConnectionRepository Class Reference

This class implements the C++ side of the ConnectionRepository object. More...

List of all members.

## Public Member Functions
| CConnectionRepository (bool has_owner_view, bool threaded_net)
| CConnectionRepository (bool has_owner_view)
| CConnectionRepository ()
| abandonMessageBundles ()
| throw out any msgs that have been queued up for message bundles
| bundleMsg (Datagram const dg)
bool | checkDatagram ()
| Returns true if a new datagram is available, false otherwise.
bool | considerFlush ()
| Sends the most recently queued data if enough time has elapsed.
| disconnect ()
| Closes the connection to the server.
bool | flush ()
| Sends the most recently queued data now.
bool | getClientDatagram ()
| Returns the client_datagram flag.
ConnectionWriter | getCw ()
| Returns the ConnectionWriter object associated with the repository.
| getDatagram (Datagram dg)
| Fills the datagram object with the datagram most recently retrieved by check_datagram().
| getDatagramIterator (DatagramIterator di)
| Fills the DatagramIterator object with the iterator for the datagram most recently retrieved by check_datagram().
DCFile | getDcFile ()
| Returns the DCFile object associated with this repository.
bool | getHandleCUpdates ()
| Returns true if this repository will process distributed updates internally in C++ code, or false if it will return them to Python.
bool | getHandleDatagramsInternally ()
| Returns the handle_datagrams_internally flag.
bool | getInQuietZone ()
| Returns true if repository is in quiet zone mode.
unsigned long long int | getMsgChannel (int offset)
| Returns the channel(s) to which the current message was sent, according to the datagram headers.
unsigned long long int | getMsgChannel ()
| Returns the channel(s) to which the current message was sent, according to the datagram headers.
int | getMsgChannelCount ()
unsigned long long int | getMsgSender ()
| Returns the sender ID of the current message, according to the datagram headers.
unsigned int | getMsgType ()
| Returns the security code associated with the current message, according to the datagram headers.
QueuedConnectionManager | getQcm ()
| Returns the QueuedConnectionManager object associated with the repository.
QueuedConnectionReader | getQcr ()
| Returns the QueuedConnectionReader object associated with the repository.
bool | getSimulatedDisconnect ()
| Returns the simulated disconnect flag.
SocketStream | getStream ()
| Returns the SocketStream that internally represents the already-established HTTP connection.
int | getTcpHeaderSize ()
| Returns the current setting of TCP header size.
float | getTimeWarning ()
| Returns the current setting of the time_warning field.
bool | getVerbose ()
| Returns the current setting of the verbose flag.
bool | getWantMessageBundling ()
| Returns true if message bundling enabled.
bool | hasOwnerView ()
| Returns true if this repository can have 'owner' views of distributed objects.
bool | isBundlingMessages ()
| Returns true if repository is queueing outgoing messages into a message bundle.
bool | isConnected ()
| Returns true if the connection to the gameserver is established and still good, false if we are not connected.
bool | sendDatagram (Datagram const dg)
| Queues the indicated datagram for sending to the server.
| sendMessageBundle (unsigned int channel, unsigned int sender_channel)
| Send network messages queued up since startMessageBundle was called.
| setClientDatagram (bool client_datagram)
| Sets the client_datagram flag.
| setConnectionHttp (HTTPChannel channel)
| Once a connection has been established via the HTTP interface, gets the connection and uses it.
| setHandleCUpdates (bool handle_c_updates)
| Set true to specify this repository should process distributed updates internally in C++ code, or false if it should return them to Python.
| setHandleDatagramsInternally (bool handle_datagrams_internally)
| Sets the handle_datagrams_internally flag.
| setInQuietZone (bool flag)
| Enables/disables quiet zone mode.
| setPythonRepository (PyObject python_repository)
| Records the pointer to the Python class that derives from CConnectionRepository.
| setSimulatedDisconnect (bool simulated_disconnect)
| Sets the simulated disconnect flag.
| setTcpHeaderSize (int tcp_header_size)
| Sets the header size of TCP packets.
| setTimeWarning (float time_warning)
| Directly sets the time_warning field.
| setVerbose (bool verbose)
| Directly sets the verbose flag.
| setWantMessageBundling (bool flag)
| Enable/disable outbound message bundling.
| shutdown ()
| May be called at application shutdown to ensure all threads are cleaned up.
| startMessageBundle ()
| Send a set of messages to the state server that will be processed atomically.
| toggleVerbose ()
| Toggles the current setting of the verbose flag.
bool | tryConnectNet (URLSpec const url)
| Uses Panda's "net" library to try to connect to the server and port named in the indicated URL.
## Static Public Member Functions
static string | getOverflowEventName ()
| Returns event string that will be thrown if the datagram reader queue overflows.

## Detailed Description

This class implements the C++ side of the ConnectionRepository object.

In particular, it manages the connection to the server once it has been opened (but does not open it directly). It manages reading and writing datagrams on the connection and monitoring for unexpected disconnects as well as handling intentional disconnects.

Certain server messages, like field updates, are handled entirely within the C++ layer, while server messages that are not understood by the C++ layer are returned up to the Python layer for processing.

## Constructor & Destructor Documentation

CConnectionRepository | ( | bool | has_owner_view,
|  | bool | threaded_net
| ) |  |

CConnectionRepository | ( | bool | has_owner_view | ) |

CConnectionRepository | ( |  | ) |

## Member Function Documentation

abandonMessageBundles | ( |  | ) |

throw out any msgs that have been queued up for message bundles

bundleMsg | ( | Datagram const | dg | ) |

bool checkDatagram | ( |  | ) |

Returns true if a new datagram is available, false otherwise.

If the return value is true, the new datagram may be retrieved via get_datagram(), or preferably, with get_datagram_iterator() and get_msg_type().

bool considerFlush | ( |  | ) |

Sends the most recently queued data if enough time has elapsed.

This only has meaning if set_collect_tcp() has been set to true.

disconnect | ( |  | ) |

Closes the connection to the server.

bool flush | ( |  | ) |

Sends the most recently queued data now.

This only has meaning if set_collect_tcp() has been set to true.

bool getClientDatagram | ( |  | ) |

Returns the client_datagram flag.

ConnectionWriter getCw | ( |  | ) |

Returns the ConnectionWriter object associated with the repository.

getDatagram | ( | Datagram | dg | ) |

Fills the datagram object with the datagram most recently retrieved by check_datagram().

getDatagramIterator | ( | DatagramIterator | di | ) |

Fills the DatagramIterator object with the iterator for the datagram most recently retrieved by check_datagram().

This iterator has already read past the datagram header and the message type, and is positioned at the beginning of data.

DCFile getDcFile | ( |  | ) |

Returns the DCFile object associated with this repository.

bool getHandleCUpdates | ( |  | ) |

Returns true if this repository will process distributed updates internally in C++ code, or false if it will return them to Python.

bool getHandleDatagramsInternally | ( |  | ) |

Returns the handle_datagrams_internally flag.

bool getInQuietZone | ( |  | ) |

Returns true if repository is in quiet zone mode.

unsigned long long int getMsgChannel | ( | int | offset | ) |

Returns the channel(s) to which the current message was sent, according to the datagram headers.

This information is not available to the client.

unsigned long long int getMsgChannel | ( |  | ) |

Returns the channel(s) to which the current message was sent, according to the datagram headers.

This information is not available to the client.

int getMsgChannelCount | ( |  | ) |

unsigned long long int getMsgSender | ( |  | ) |

Returns the sender ID of the current message, according to the datagram headers.

This information is not available to the client.

unsigned int getMsgType | ( |  | ) |

Returns the security code associated with the current message, according to the datagram headers.

This information is not available to the client. INLINE unsigned char CConnectionRepository:: get_sec_code() const { return _sec_code; } Function: CConnectionRepository.get_msg_type Access: Published Description: Returns the type ID of the current message, according to the datagram headers.

static string getOverflowEventName | ( |  | ) | `[static]`

Returns event string that will be thrown if the datagram reader queue overflows.

QueuedConnectionManager getQcm | ( |  | ) |

Returns the QueuedConnectionManager object associated with the repository.

QueuedConnectionReader getQcr | ( |  | ) |

Returns the QueuedConnectionReader object associated with the repository.

bool getSimulatedDisconnect | ( |  | ) |

Returns the simulated disconnect flag.

While this is true, no datagrams will be retrieved from or sent to the server. The idea is to simulate a temporary network outage.

SocketStream getStream | ( |  | ) |

Returns the SocketStream that internally represents the already-established HTTP connection.

Returns NULL if there is no current HTTP connection.

int getTcpHeaderSize | ( |  | ) |

Returns the current setting of TCP header size.

See set_tcp_header_size().

float getTimeWarning | ( |  | ) |

Returns the current setting of the time_warning field.

bool getVerbose | ( |  | ) |

Returns the current setting of the verbose flag.

When true, this describes every message going back and forth on the wire.

bool getWantMessageBundling | ( |  | ) |

Returns true if message bundling enabled.

bool hasOwnerView | ( |  | ) |

Returns true if this repository can have 'owner' views of distributed objects.

bool isBundlingMessages | ( |  | ) |

Returns true if repository is queueing outgoing messages into a message bundle.

bool isConnected | ( |  | ) |

Returns true if the connection to the gameserver is established and still good, false if we are not connected.

A false value means either (a) we never successfully connected, (b) we explicitly called disconnect(), or (c) we were connected, but the connection was spontaneously lost.

bool sendDatagram | ( | Datagram const | dg | ) |

Queues the indicated datagram for sending to the server.

It may not get sent immediately if collect_tcp is in effect; call flush() to guarantee it is sent now.

sendMessageBundle | ( | unsigned int | channel,
|  | unsigned int | sender_channel
| ) |  |

Send network messages queued up since startMessageBundle was called.

setClientDatagram | ( | bool | client_datagram | ) |

Sets the client_datagram flag.

If this is true, incoming datagrams are not expected to be prefixed with the server routing information like message sender, channel number, etc.; otherwise, these server fields are parsed and removed from each incoming datagram.

setConnectionHttp | ( | HTTPChannel | channel | ) |

Once a connection has been established via the HTTP interface, gets the connection and uses it.

The supplied HTTPChannel object must have a connection available via get_connection().

setHandleCUpdates | ( | bool | handle_c_updates | ) |

Set true to specify this repository should process distributed updates internally in C++ code, or false if it should return them to Python.

setHandleDatagramsInternally | ( | bool | handle_datagrams_internally | ) |

Sets the handle_datagrams_internally flag.

When true, certain message types can be handled by the C++ code in in this module. When false, all datagrams, regardless of message type, are passed up to Python for processing.

The CMU distributed-object implementation requires this to be set false.

setInQuietZone | ( | bool | flag | ) |

Enables/disables quiet zone mode.

setPythonRepository | ( | PyObject | python_repository | ) |

Records the pointer to the Python class that derives from CConnectionRepository.

This allows the C++ implementation to directly manipulation some python structures on the repository.

setSimulatedDisconnect | ( | bool | simulated_disconnect | ) |

Sets the simulated disconnect flag.

While this is true, no datagrams will be retrieved from or sent to the server. The idea is to simulate a temporary network outage.

setTcpHeaderSize | ( | int | tcp_header_size | ) |

Sets the header size of TCP packets.

At the present, legal values for this are 0, 2, or 4; this specifies the number of bytes to use encode the datagram length at the start of each TCP datagram. Sender and receiver must independently agree on this.

setTimeWarning | ( | float | time_warning | ) |

Directly sets the time_warning field.

When non zero, this describes every message going back and forth on the wire when the msg handling time is over it

setVerbose | ( | bool | verbose | ) |

Directly sets the verbose flag.

When true, this describes every message going back and forth on the wire.

setWantMessageBundling | ( | bool | flag | ) |

Enable/disable outbound message bundling.

shutdown | ( |  | ) |

May be called at application shutdown to ensure all threads are cleaned up.

startMessageBundle | ( |  | ) |

Send a set of messages to the state server that will be processed atomically.

For instance, you can do a combined setLocation/setPos and prevent race conditions where clients briefly get the setLocation but not the setPos, because the state server hasn't processed the setPos yet

toggleVerbose | ( |  | ) |

Toggles the current setting of the verbose flag.

When true, this describes every message going back and forth on the wire.

bool tryConnectNet | ( | URLSpec const | url | ) |

Uses Panda's "net" library to try to connect to the server and port named in the indicated URL.

Returns true if successful, false otherwise.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties